package geniusweb.domaineditor.panels;

import java.awt.BorderLayout;

import javax.swing.JPanel;

import geniusweb.domaineditor.model.DiscreteValueSetModel;
import geniusweb.domaineditor.model.NumberValueSetModel;
import geniusweb.domaineditor.model.ValueSetModel;
import tudelft.utilities.logging.Reporter;
import tudelft.utilities.mvc.model.StringModel;
import tudelft.utilities.mvc.panels.LabeledPanel;
import tudelft.utilities.mvc.panels.StringPanel;

/**
 * Factory to create ValueSet editor
 * 
 */
public class ValueSetEditorFactory {

//	private JComboBox typeselector = new JComboBox(Type.values());

	/**
	 * 
	 * @param namemodel a {@link StringModel} holding name of the issue
	 * @param model     the {@link ValueSetModel} containing the issue values.
	 * @return editor panel for this issue
	 */
	public JPanel create(StringModel namemodel, ValueSetModel model,
			Reporter log) {
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(new LabeledPanel("values for issue ",
				new StringPanel(namemodel)), BorderLayout.NORTH);
		panel.add(create1(namemodel, model, log), BorderLayout.CENTER);
		return panel;
	}

	private JPanel create1(StringModel namemodel, ValueSetModel model,
			Reporter log) {
		if (model instanceof DiscreteValueSetModel)
			return new DiscreteValueSetPanel(namemodel,
					(DiscreteValueSetModel) model, log);
		if (model instanceof NumberValueSetModel)
			return new NumberValueSetPanel(namemodel,
					(NumberValueSetModel) model);
		throw new IllegalArgumentException("Unknown model type " + model);
	}

}
